## ros-galactic-rosbag2-bag-v2-plugins 0.2.0

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.5)
project(rosbag2_bag_v2_plugins)

# Default to C99
if(NOT CMAKE_C_STANDARD)
  set(CMAKE_C_STANDARD 99)
endif()

# Default to C++14
if(NOT CMAKE_CXX_STANDARD)
  set(CMAKE_CXX_STANDARD 14)
endif()

if(CMAKE_COMPILER_IS_GNUCXX OR CMAKE_CXX_COMPILER_ID MATCHES "Clang")
  add_compile_options(-Wall -Wextra -Wpedantic)
endif()

find_package(ament_cmake REQUIRED)

# include bridge first to not create package if ros1 packages cannot be found
find_package(ros1_bridge QUIET)
if(NOT ros1_bridge_FOUND)
  message(FATAL_ERROR "Failed to find ros1_bridge, cannot build.")
endif()

find_ros1_package(roscpp)
if(NOT ros1_roscpp_FOUND)
  message(FATAL_ERROR "Failed to find ROS 1 roscpp, cannot build.")
endif()

find_package(class_loader REQUIRED)
find_package(pluginlib REQUIRED)
find_package(rclcpp REQUIRED)
find_package(rcpputils REQUIRED)
find_package(rcutils REQUIRED)
find_package(rosbag2_cpp REQUIRED)
find_package(rosbag2_storage REQUIRED)
find_package(ros1_rosbag_storage REQUIRED)  # provided by ros1_rosbag_storage_vendor

# Find transitive ros1 dependencies for ros1_rosbag_storage
find_ros1_package(cpp_common)
find_ros1_package(roscpp_serialization)
find_ros1_package(roscpp_traits)
find_ros1_package(rostime)
find_ros1_package(roslz4)

set(generated_path "${CMAKE_BINARY_DIR}/generated")
set(generated_files "${generated_path}/convert_rosbag_message.cpp")

add_custom_command(
  OUTPUT ${generated_files}
  COMMAND python3 ${CMAKE_CURRENT_SOURCE_DIR}/src/generate_converter_cpp.py
  --output-path "${generated_path}" --template-dir ${CMAKE_CURRENT_SOURCE_DIR}/src/rosbag2_bag_v2_plugins
  WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}
)

find_ros1_interface_packages(ros1_message_packages)

set(prefixed_ros1_message_packages "")
foreach(ros1_message_package ${ros1_message_packages})
  if(NOT "${ros1_message_package}" STREQUAL "nodelet")
    find_ros1_package(${ros1_message_package} REQUIRED)
    list(APPEND prefixed_ros1_message_packages "ros1_${ros1_message_package}")
  endif()
endforeach()

# generate conversion methods
ament_index_get_resources(ros2_message_packages "rosidl_interfaces")
foreach(message_package ${ros2_message_packages})
  find_package(${message_package} REQUIRED)
  message(STATUS "Found ${message_package}: ${${message_package}_VERSION} (${${message_package}_DIR})")
endforeach()

add_library(
  ${PROJECT_NAME} SHARED
  src/rosbag2_bag_v2_plugins/converter/rosbag_v2_deserializer.cpp
  src/rosbag2_bag_v2_plugins/storage/rosbag_output_stream.cpp
  src/rosbag2_bag_v2_plugins/storage/rosbag_v2_storage.cpp
  ${generated_files})

ament_target_dependencies(${PROJECT_NAME}
  ros1_rosbag_storage
  class_loader
  rclcpp
  rosbag2_cpp
  rosbag2_storage
  ros1_bridge
  pluginlib
  ros1_cpp_common
  ros1_roscpp
  ros1_roscpp_serialization
  ros1_roscpp_traits
  ros1_rostime
  ros1_roslz4
  ${ros2_message_packages}
  ${prefixed_ros1_message_packages})

target_include_directories(${PROJECT_NAME}
  PUBLIC
  $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/src/rosbag2_bag_v2_plugins>
)

# This is necessary on some systems where CMake declares ros2 paths as "system paths" thereby
# messing up the include order. This results in this package being built with the wrong pluginlib
# i.e. the pluginlib from ROS 1. Symptoms of this problem are missing symbols for class loader
# classes (i.e. class_loader::impl::...) when linking the tests in this package
set_target_properties(${PROJECT_NAME} PROPERTIES NO_SYSTEM_FROM_IMPORTED 1)

# Causes the visibility macros to use dllexport rather than dllimport,
# which is appropriate when building the dll but not consuming it.
target_compile_definitions(${PROJECT_NAME} PRIVATE
  ROSBAG2_BAG_V2_PLUGINS_BUILDING_DLL)

pluginlib_export_plugin_description_file(rosbag2_storage storage_plugin_description.xml)
pluginlib_export_plugin_description_file(rosbag2_cpp converter_plugin_description.xml)

install(
  TARGETS ${PROJECT_NAME}
  ARCHIVE DESTINATION lib
  LIBRARY DESTINATION lib
  RUNTIME DESTINATION bin)

ament_export_libraries(${PROJECT_NAME})
ament_export_dependencies(rosbag2_storage)
ament_export_dependencies(rosbag2 ros1_rosbag_storage rosbag2_storage)

if(BUILD_TESTING)
  find_package(ament_cmake_gmock REQUIRED)
  find_package(ament_lint_auto REQUIRED)
  find_package(rosbag2_test_common REQUIRED)
  find_package(rosbag2_transport REQUIRED)

  ament_lint_auto_find_test_dependencies()

  add_definitions(-D_SRC_RESOURCES_DIR_PATH="${CMAKE_CURRENT_SOURCE_DIR}/resources")

  ament_add_gmock(test_rosbag_v2_storage
    test/rosbag2_bag_v2_plugins/test_rosbag_v2_storage.cpp
    WORKING_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR})
  if(TARGET test_rosbag_v2_storage)
    target_include_directories(test_rosbag_v2_storage
      PUBLIC
        $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/src>)
    target_link_libraries(test_rosbag_v2_storage ${PROJECT_NAME})
    ament_target_dependencies(test_rosbag_v2_storage
      rosbag2_test_common)
  endif()

  ament_add_gmock(test_rosbag_output_stream
    test/rosbag2_bag_v2_plugins/test_rosbag_output_stream.cpp
    WORKING_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR})
  if(TARGET test_rosbag_output_stream)
    target_include_directories(test_rosbag_output_stream
      PUBLIC
      $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/src>)
    target_link_libraries(test_rosbag_output_stream ${PROJECT_NAME})
    ament_target_dependencies(test_rosbag_output_stream
      rosbag2_test_common)
  endif()

  ament_add_gmock(test_rosbag2_play_rosbag_v2_end_to_end
    test/rosbag2_bag_v2_plugins/test_rosbag2_play_rosbag_v2_end_to_end.cpp
    WORKING_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR})
  if(TARGET test_rosbag2_play_rosbag_v2_end_to_end)
    ament_target_dependencies(test_rosbag2_play_rosbag_v2_end_to_end
      rosbag2_storage
      rclcpp
      rosbag2_test_common
      rosbag2_transport
      std_msgs)
  endif()

  ament_add_gmock(test_rosbag2_info_rosbag_v2_end_to_end
    test/rosbag2_bag_v2_plugins/test_rosbag2_info_rosbag_v2_end_to_end.cpp
    WORKING_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR})
  if(TARGET test_rosbag2_info_rosbag_v2_end_to_end)
    ament_target_dependencies(test_rosbag2_info_rosbag_v2_end_to_end
      rosbag2_storage
      rclcpp
      rosbag2_test_common
      std_msgs)
  endif()
endif()

ament_package()

=== debian/changelog ===
ros-galactic-rosbag2-bag-v2-plugins (0.2.0-1focal) focal; urgency=high

  * remove rosbag2 transport (#43 <https://github.com/ros2/rosbag2_bag_v2/issues/43>)
  * Contributors: Karsten Knese

 -- Karsten Knese <karsten@openrobotics.org>  Tue, 18 May 2021 07:00:00 -0000

ros-galactic-rosbag2-bag-v2-plugins (0.1.0-1focal) focal; urgency=high

  * Update to the latest rosbag1. (#40 <https://github.com/ros2/rosbag2_bag_v2/issues/40>)
  * Fix build for latest rosbag2 StorageOptions API (#38 <https://github.com/ros2/rosbag2_bag_v2/issues/38>)
  * Contributors: Chris Lalancette, Emerson Knapp

 -- Karsten Knese <karsten@openrobotics.org>  Mon, 01 Feb 2021 08:00:00 -0000

ros-galactic-rosbag2-bag-v2-plugins (0.0.9-1focal) focal; urgency=high



 -- Karsten Knese <karsten@openrobotics.org>  Wed, 03 Jun 2020 07:00:00 -0000

ros-galactic-rosbag2-bag-v2-plugins (0.0.8-1focal) focal; urgency=high

  * Adapt storage interface for filtering topics. (#28 <https://github.com/ros2/rosbag2_bag_v2/issues/28>)
  * Raise an error instead of a warning without ROS 1. (#23 <https://github.com/ros2/rosbag2_bag_v2/issues/23>)
  * Use rosbag2 metapackage. (#16 <https://github.com/ros2/rosbag2_bag_v2/issues/16>)
  * Contributors: Emerson Knapp, Mabel Zhang, Zachary Michaels

 -- Karsten Knese <karsten@openrobotics.org>  Fri, 08 May 2020 07:00:00 -0000

ros-galactic-rosbag2-bag-v2-plugins (0.0.7-1focal) focal; urgency=high

  * Update interfaces to eloquent API. (#8 <https://github.com/ros2/rosbag2_bag_v2/issues/8>)
  * Implement changes in IO interfaces. (#7 <https://github.com/ros2/rosbag2_bag_v2/issues/7>)
  * Contributors: Zachary Michaels

 -- Karsten Knese <karsten@openrobotics.org>  Mon, 18 Nov 2019 08:00:00 -0000

ros-galactic-rosbag2-bag-v2-plugins (0.0.6-1focal) focal; urgency=high

  * warn when roscpp is not found (#4 <https://github.com/ros2/rosbag2_bag_v2/issues/4>)
    Signed-off-by: osrf <mailto:karsten@openrobotics.org>
  * New type identification (#3 <https://github.com/ros2/rosbag2_bag_v2/issues/3>)
    * update logging macros
    Signed-off-by: osrf <mailto:karsten@openrobotics.org>
    * correct typo in filename
    Signed-off-by: osrf <mailto:karsten@openrobotics.org>
    * use new type identification
    Signed-off-by: osrf <mailto:karsten@openrobotics.org>
  * compile tests (#2 <https://github.com/ros2/rosbag2_bag_v2/issues/2>)
    Signed-off-by: Karsten Knese <mailto:karsten@openrobotics.org>
  * remove duplicate repos (#1 <https://github.com/ros2/rosbag2_bag_v2/issues/1>)
    Signed-off-by: Karsten Knese <mailto:karsten@openrobotics.org>
  * correct missing linter errors (#96 <https://github.com/ros2/rosbag2_bag_v2/issues/96>)
    Signed-off-by: Karsten Knese <mailto:karsten@openrobotics.org>
  * removed dependency to ros1_bridge package (#90 <https://github.com/ros2/rosbag2_bag_v2/issues/90>)
    * removed dependency to ros1_bridge package:
    * checking if package is available
    * if not skipping (with warnings)
    * now rosbag2_tests builds on systems without ros1
    * check ros1 deps correctly on all packages
    * add ros1_bridge to test package
    * silently try to find the bridge
  * Contributors: DensoADAS, Karsten Knese

 -- Karsten Knese <karsten@openrobotics.org>  Thu, 06 Jun 2019 07:00:00 -0000

ros-galactic-rosbag2-bag-v2-plugins (0.0.5-1focal) focal; urgency=high



 -- Karsten Knese <karsten@openrobotics.org>  Thu, 27 Dec 2018 08:00:00 -0000

ros-galactic-rosbag2-bag-v2-plugins (0.0.4-1focal) focal; urgency=high

  * 0.0.3
  * manually bump version number as catkin_prepare_release complains
  * generate changelog
  * Contributors: Karsten Knese, Martin Idel

 -- Karsten Knese <karsten@openrobotics.org>  Wed, 19 Dec 2018 08:00:00 -0000

ros-galactic-rosbag2-bag-v2-plugins (0.0.3-1focal) focal; urgency=high

  * Release fixes (#73 <https://github.com/ros2/rosbag2/issues/73>)
  * Play old bagfiles (#69 <https://github.com/ros2/rosbag2/issues/69>)
  * Contributors: Karsten Knese, Martin Idel

 -- Karsten Knese <karsten@openrobotics.org>  Fri, 14 Dec 2018 08:00:00 -0000

ros-galactic-rosbag2-bag-v2-plugins (0.0.2-1focal) focal; urgency=high



 -- Karsten Knese <karsten@openrobotics.org>  Wed, 12 Dec 2018 08:00:00 -0000

ros-galactic-rosbag2-bag-v2-plugins (0.0.1-1focal) focal; urgency=high



 -- Karsten Knese <karsten@openrobotics.org>  Tue, 11 Dec 2018 08:00:00 -0000

=== debian/control ===
Source: ros-galactic-rosbag2-bag-v2-plugins
Section: misc
Priority: optional
Maintainer: Karsten Knese <karsten@openrobotics.org>
Build-Depends: debhelper (>= 9.0.0), ros-galactic-ament-cmake, ros-galactic-ament-cmake-gmock, ros-galactic-ament-lint-auto, ros-galactic-ament-lint-common, ros-galactic-class-loader, ros-galactic-pluginlib, ros-galactic-rclcpp, ros-galactic-rcutils, ros-galactic-ros1-bridge, ros-galactic-ros1-rosbag-storage-vendor, ros-galactic-rosbag2, ros-galactic-rosbag2-storage, ros-galactic-rosbag2-test-common, ros-galactic-rosbag2-transport, ros-galactic-std-msgs, ros-galactic-ros-workspace
Homepage: 
Standards-Version: 3.9.2

Package: ros-galactic-rosbag2-bag-v2-plugins
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, ros-galactic-class-loader, ros-galactic-pluginlib, ros-galactic-rclcpp, ros-galactic-rcutils, ros-galactic-ros1-bridge, ros-galactic-ros1-rosbag-storage-vendor, ros-galactic-rosbag2, ros-galactic-rosbag2-storage, ros-galactic-ros-workspace
Description: Package containing storage and converter plugins for rosbag 1

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# Sample debian/rules that uses debhelper.
# This file was originally written by Joey Hess and Craig Small.
# As a special exception, when this file is copied by dh-make into a
# dh-make output file, you may use that output file without restriction.
# This special exception was added by Craig Small in version 0.37 of dh-make.

# Uncomment this to turn on verbose mode.
export DH_VERBOSE=1
# TODO: remove the LDFLAGS override.  It's here to avoid esoteric problems
# of this sort:
#  https://code.ros.org/trac/ros/ticket/2977
#  https://code.ros.org/trac/ros/ticket/3842
export LDFLAGS=
export PKG_CONFIG_PATH=/opt/ros/galactic/lib/pkgconfig
# Explicitly enable -DNDEBUG, see:
# 	https://github.com/ros-infrastructure/bloom/issues/327
export DEB_CXXFLAGS_MAINT_APPEND=-DNDEBUG

%:
	dh $@ -v --buildsystem=cmake

override_dh_auto_configure:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/noetic/setup.sh" ]; then . "/opt/ros/noetic/setup.sh"; fi && \
	if [ -f "/opt/ros/galactic/setup.sh" ]; then . "/opt/ros/galactic/setup.sh"; fi && \
	export CMAKE_PREFIX_PATH=${AMENT_PREFIX_PATH}:${CMAKE_PREFIX_PATH} && \
	dh_auto_configure -- \
		-DCMAKE_INSTALL_PREFIX="/opt/ros/galactic" \
		-DAMENT_PREFIX_PATH="/opt/ros/galactic" \
		-DCMAKE_PREFIX_PATH="/opt/ros/galactic"

override_dh_auto_build:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/noetic/setup.sh" ]; then . "/opt/ros/noetic/setup.sh"; fi && \
	if [ -f "/opt/ros/galactic/setup.sh" ]; then . "/opt/ros/galactic/setup.sh"; fi && \
	export CMAKE_PREFIX_PATH=${AMENT_PREFIX_PATH}:${CMAKE_PREFIX_PATH} && \
	dh_auto_build

override_dh_auto_test:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	echo -- Running tests. Even if one of them fails the build is not canceled.
	if [ -f "/opt/ros/noetic/setup.sh" ]; then . "/opt/ros/noetic/setup.sh"; fi && \
	if [ -f "/opt/ros/galactic/setup.sh" ]; then . "/opt/ros/galactic/setup.sh"; fi && \
	export CMAKE_PREFIX_PATH=${AMENT_PREFIX_PATH}:${CMAKE_PREFIX_PATH} && \
	dh_auto_test || true

override_dh_shlibdeps:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/noetic/setup.sh" ]; then . "/opt/ros/noetic/setup.sh"; fi && \
	if [ -f "/opt/ros/galactic/setup.sh" ]; then . "/opt/ros/galactic/setup.sh"; fi && \
	export CMAKE_PREFIX_PATH=${AMENT_PREFIX_PATH}:${CMAKE_PREFIX_PATH} && \
	dh_shlibdeps -l$(CURDIR)/debian/ros-galactic-rosbag2-bag-v2-plugins//opt/ros/galactic/lib/

override_dh_auto_install:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/noetic/setup.sh" ]; then . "/opt/ros/noetic/setup.sh"; fi && \
	if [ -f "/opt/ros/galactic/setup.sh" ]; then . "/opt/ros/galactic/setup.sh"; fi && \
	export CMAKE_PREFIX_PATH=${AMENT_PREFIX_PATH}:${CMAKE_PREFIX_PATH} && \
	dh_auto_install
